#include <iostream>
using namespace std;

const int MAXNUM = 20;
const int MAXL = 50;

const float SOGLIA = 5000.0;

struct Richiesta
{ int nc;
  int va;
  float reddito;
  char nome[MAXL];
  char cognome[MAXL];
};

struct CodaRichieste
{ Richiesta ric[MAXNUM];
  int front, back;
};

bool inserisci(const Richiesta r, CodaRichieste* cr); 
int posizione(const char c[], const char n[], const CodaRichieste* cr);
bool nuovaUnita(int v, CodaRichieste* cr, Richiesta* pr);
bool salva(const CodaRichieste* cr, const char nf[]);
int perreddito(const CodaRichieste* cr, Richiesta ar[]);

void stampaRic(Richiesta r) { 
  cout << r.cognome << ", " << r.nome << ", " << r.reddito 
       << ", " << r.nc << ", " << r.va << endl;
}

void stampaCoda(CodaRichieste* pcr){
  for(int i=pcr->front; i!=pcr->back; i=(i+1)%MAXNUM)
    stampaRic(pcr->ric[i]);
}

void ins(CodaRichieste* pcr, char c[], char n[], float red, int nc, int va) {
  Richiesta r;
  strcpy(r.cognome, c);
  strcpy(r.nome, n);
  r.reddito = red;
  r.nc = nc;
  r.va = va;
  cout << "La richiesta" << endl;  
  stampaRic(r);
  if(inserisci(r, pcr)) 
    cout << "e' stata inserita" << endl;
  else 
    cout << "non e' stata inserita" << endl; 
}

int main(){
  CodaRichieste cr;
  Richiesta tmp;
  cr.front = 0;
  cr.back = 0; 

  ins(&cr, "Rossi", "Mario", 10200.0, 3, 3);
  ins(&cr, "Bianchi", "Luigi", 9800.0, 4, 3);
  ins(&cr, "Verdi", "Antonio", 11110.0, 3, 3);
  ins(&cr, "Brambilla", "Gigi", 75110.0, 2, 3);
  ins(&cr, "Ruotolo", "Francesco", 12880.0, 4, 4);
  ins(&cr, "Buti", "Oreste", 10880.0, 4, 4);
  ins(&cr, "Roncola", "Armando", 9480.0, 5, 4);

  cout << "Stato della coda:" << endl;
  stampaCoda(&cr);
  system("PAUSE");

  cout << "La posizione in graduatoria di Ruotolo Francesco e': " 
       << posizione("Ruotolo", "Francesco", &cr) << endl;
  cout << "La posizione in graduatoria di Rossi Mario e': " 
       << posizione("Rossi", "Mario", &cr) << endl;
  cout << "La posizione in graduatoria di Neri Felice e': " 
       << posizione("Neri", "Felice", &cr) << endl;
  
  if(nuovaUnita(2, &cr, &tmp)) {
    cout << "Unita' abitativa da 2 vani asseganata a " << endl;
    stampaRic(tmp);
  } else 
    cout << "Unita' abitativa da 2 vani non assegnata" << endl; 

  if(nuovaUnita(3, &cr, &tmp)) {
    cout << "Unita' abitativa da 3 vani asseganata a " << endl;
    stampaRic(tmp);
  } else 
    cout << "Unita' abitativa da 3 vani non assegnata" << endl; 

  if(nuovaUnita(4, &cr, &tmp)) {
    cout << "Unita' abitativa da 4 vani asseganata a " << endl;
    stampaRic(tmp);
  } else 
    cout << "Unita' abitativa da 4 vani non assegnata" << endl; 
   
  cout << "Stato della coda:" << endl;
  stampaCoda(&cr);
  system("PAUSE");
    
  if(salva(&cr, "output.txt")) {
    cout << "Salvataggio eseguito." << endl;
    cout << "Contenuto del file:" << endl;
    system("type output.txt");
  } else 
    cout << "Salvataggio non eseguito." << endl;
  system("PAUSE");
   
  Richiesta arr[MAXNUM];
  int n = perreddito(&cr, arr);
  cout << "Richieste ordinate per reddito pro-capite:" << endl;
  for (int i=0; i<n; i++)
    stampaRic(arr[i]);
  system("PAUSE");

}
