#include <fstream>
using namespace std;

const int MAXNUM = 20;
const int MAXL = 50;

const float SOGLIA = 5000.0;

struct Richiesta
{ int nc;
  int va;
  float reddito;
  char nome[MAXL];
  char cognome[MAXL];
};

struct CodaRichieste
{ Richiesta ric[MAXNUM];
  int front, back;
};

bool inserisci(const Richiesta r, CodaRichieste* cr) {
  if ((cr->back + 1) % MAXNUM == cr->front || r.reddito/r.nc > SOGLIA)
    return false;
  cr->ric[cr->back] = r;
  cr->back = (cr->back + 1) % MAXNUM;
  return true;
}

int posizione(const char c[], const char n[], const CodaRichieste* cr) {
  for(int i=cr->front; i != cr->back; i = (i+1)%MAXNUM)
    if(strcmp(n, cr->ric[i].nome) == 0 && strcmp(c, cr->ric[i].cognome) == 0) 
      return (i + MAXNUM - cr->front) % MAXNUM;
  return 0;
}

bool nuovaUnita(int v, CodaRichieste* cr, Richiesta* pr) {
  for(int i=cr->front; i != cr->back; i = (i+1)%MAXNUM)
    if(cr->ric[i].va == v) {
      *pr = cr->ric[i];
      for(int j=i; j !=cr->back-1; j = (j+1)%MAXNUM)
        cr->ric[j] = cr->ric[j+1];
      cr->back = (cr->back == 0 ? MAXNUM - 1 : cr->back - 1);
      return true;
    }
  return false;
}

bool salva(const CodaRichieste* cr, const char nf[]) {
  fstream fs;
  fs.open(nf, ios::out);
  if(!fs) 
    return false;
  for(int i=cr->front; i != cr->back; i = (i+1)%MAXNUM) {
    fs << cr->ric[i].cognome << ", " << cr->ric[i].nome << ", " 
       << cr->ric[i].reddito << ", " << cr->ric[i].nc << ", " 
       << cr->ric[i].va << endl;
  }
  if(!fs)
    return false;
  return true;
}

void scambia(Richiesta r[], int x, int y) {
    Richiesta lav = r[x];
    r[x] = r[y];
    r[y] = lav;
}

void ordina(Richiesta v[], int n) {
  bool ordinato = false;
  for(int i = 0; i < n-1 && !ordinato; i++) {
    ordinato = true;
    for(int j = n-1; j >= i+1; j--)
      if(v[j].reddito/v[j].nc < v[j-1].reddito/v[j-1].nc) {
        scambia(v, j, j-1);
        ordinato = false;
      }
  }
}

int perreddito(const CodaRichieste* cr, Richiesta ar[]) {
  int conta = 0;
  for(int i=cr->front; i != cr->back; i = (i+1)%MAXNUM) 
    ar[conta++] = cr->ric[i];
  ordina(ar, conta);
  return conta;
}
